import React from "react";
declare type MiniBrowserStep = {
    /**
     * The url to display on the navigation bar.
     */
    url?: string;
    /**
     * Override the url used for the iframe and "Open in new tab" button.
     */
    loadUrl?: string;
    /**
     * Scale the content of the browser.
     */
    zoom?: number;
    /**
     * Prepend the current origin to the url.
     */
    prependOrigin?: boolean;
    /**
     * The content to display in the browser. If not provided, an iframe for the url will be displayed.
     */
    children?: React.ReactNode;
};
declare type InternalStep = {
    displayUrl?: string;
    loadUrl?: string;
    children?: React.ReactNode;
    zoom: number;
};
export { useSteps, MiniBrowserStep, transformUrl };
declare function useSteps(steps: MiniBrowserStep[] | undefined): InternalStep[];
declare function transformUrl(url: string | undefined, loadUrl: string | undefined, prependOrigin: boolean | undefined): {
    displayUrl: string | undefined;
    loadUrl: string | undefined;
};
